; CPUs/StrongARM/ARMCache.s
; ARMCache module for the Intel StrongARM
;
; 30/Sep/1999 ned

	AREA	ARMCache, CODE, READONLY

	; Include ARMCore constants
	INCLUDE ArmCacheH.s

	; Include zero page map
	INCLUDE Core/ARM/CommonH.s

	; Exports from this module
	EXPORT	ARMCache_Initialise
	EXPORT	ARMCache_Set

ARMCache_Initialise
	; On entry R9=ptr to zero space
	MOV	PC, R14

ARMCache_Set
	; R0=bits to set
	; R1=bits to clr
	STMFD	R13!,{R2}
	LDR	R2,[R9,#HALZP_ARMCORE_CTRLREG]
	BIC	R2,R2,R1
	ORR	R2,R2,R0
	STR	R2,[R9,#HALZP_ARMCORE_CTRLREG]
	MCR	p15, 0, R2, c1, c0, 0
	LDMFD	R13!,{R2}
	MOV	PC, R14

	END
