; Core/CommonH.s
; Defines common things across all modules
;
; 01/Oct/1999 ned

; Always include board defines
	INCLUDE		BoardDefinesH.s

; Constants - Processor related
IBit		EQU	(1<<7)
FBit		EQU	(1<<6)
Mode_Bits	EQU	0x1f
Mode_User32	EQU	0x10
Mode_FIQ32	EQU	0x11
Mode_IRQ32	EQU	0x12
Mode_SVC32	EQU	0x13
Mode_Abort32	EQU	0x17
Mode_Undef32	EQU	0x1b

; SWIs available to us
OS_IntOn	EQU	0x13
OS_IntOff	EQU	0x14
OS_EnterOS	EQU	0x16

; Equivalent to struct HALError
HALERROR_MODULE			EQU	0
HALERROR_CODE			EQU	8
HALERROR_MESSAGE		EQU	12
HALERROR_SIZEOF			EQU	HALERROR_MESSAGE		+4

; Equivalent to struct HALUARTBlk
HALUARTBLK_UARTADDR		EQU	0
HALUARTBLK_SIZEOF		EQU	HALUARTBLK_UARTADDR		+4

; Equivalent to HALZeroPage
HALZP_SCRATCH			EQU	BOARD_HALZPLOCATION
HALZP_ARMCORE_CPUTYPE		EQU	HALZP_SCRATCH			+4
HALZP_ARMCORE_CTRLREG		EQU	HALZP_ARMCORE_CPUTYPE		+4
HALZP_ARMMMU_TTBREG		EQU	HALZP_ARMCORE_CTRLREG		+4
HALZP_DRAMBASE			EQU	HALZP_ARMMMU_TTBREG		+4
HALZP_DRAMTOP			EQU	HALZP_DRAMBASE			+4
HALZP_STDOUT_UARTBLK		EQU	HALZP_DRAMTOP		+4
; Exception handlers
HALZP_HANDLERS_SIZEOF		EQU	12
HALZP_START_OF_HANDLERS		EQU	HALZP_STDOUT_UARTBLK		+4
HALZP_UNDEFE_HANDLERS		EQU	HALZP_START_OF_HANDLERS
HALZP_SWIE_HANDLERS		EQU	HALZP_UNDEFE_HANDLERS		+(HALZP_HANDLERS_SIZEOF * UndefinedExcptHandlers)
HALZP_PABORTE_HANDLERS		EQU	HALZP_SWIE_HANDLERS		+(HALZP_HANDLERS_SIZEOF * SWIExcptHandlers)
HALZP_DABORTE_HANDLERS		EQU	HALZP_PABORTE_HANDLERS		+(HALZP_HANDLERS_SIZEOF * PAbortExcptHandlers)
HALZP_IRQE_HANDLERS		EQU	HALZP_DABORTE_HANDLERS		+(HALZP_HANDLERS_SIZEOF * DAbortExcptHandlers)
HALZP_FIQE_HANDLERS		EQU	HALZP_IRQE_HANDLERS		+(HALZP_HANDLERS_SIZEOF * IRQExcptHandlers)
HALZP_END_OF_HANDLERS		EQU	HALZP_FIQE_HANDLERS		+(HALZP_HANDLERS_SIZEOF * FIQExcptHandlers)
HALZP_HALZPEND			EQU	HALZP_END_OF_HANDLERS


	[ :DEF: DEMON
OS_Exit		EQU	0x11
	]

	[ :DEF: ANGEL
angel_SWIreason_WriteC			EQU	0x3
angel_SWIreason_ReadC			EQU	0x7
angel_SWIreason_EnterSVC		EQU	0x17
angel_SWIreason_ReportException		EQU	0x18

ADP_Stopped_ApplicationExit		EQU	0x20026
	]

	END
