/* Core/io/DebugIO.c
Provides functions to output to a debug output

01/Oct/1999 ned
*/

#include "DebugIO.h"

#ifdef __cplusplus
extern "C" {
#endif

static DbgIO_UARTDetails _stdout;

extern HALError *DbgIO_Initialise()
{
	return 0;
}

extern HALError *DbgIO_Finalise()
{
	HALZeroPage *zp;
	zp=BOARD_RETURNZPLOCATION();

	if(_stdout.finalise)
	{
		HALError *ret;
		ret=(_stdout.finalise)(zp->DbgIO_UARTBlk);
		if(ret) return ret;
	}
	return 0;
}

extern HALError *DbgIO_Set(DbgIO_UARTDetails *d, HALUARTBlk *uartblk, void *uartaddr)
{
	HALZeroPage *zp;
	zp=BOARD_RETURNZPLOCATION();

	if(_stdout.finalise)
	{
		HALError *ret;
		ret=(_stdout.finalise)(zp->DbgIO_UARTBlk);
		if(ret) return ret;
	}
	_stdout=*d;
	zp->DbgIO_UARTBlk=uartblk;
	if(_stdout.initialise)
	{
		HALError *ret;
		ret=(_stdout.initialise)(zp->DbgIO_UARTBlk, uartaddr);
		if(ret)
		{
			_stdout.finalise=0;
			return ret;
		}
	}
	return 0;
}

extern HALError *DbgIO_Write0(const char *cstr)
{
	char *sptr, *str;
	str=(char *) cstr;

	for(sptr=str; *sptr!=0; sptr++)
	{
		HALError *ret;
		ret=DbgIO_WriteC(*sptr);
		if(ret) return ret;
	}
	return 0;
}

extern HALError *DbgIO_WriteC(const char c)
{
	HALError *ret;
	HALZeroPage *zp;
	zp=BOARD_RETURNZPLOCATION();

	if(_stdout.send)
	{
		ret=(_stdout.send)(zp->DbgIO_UARTBlk, &c, 1);
		if(ret) return ret;
	}
	return 0;
}

extern HALError *DbgIO_ReadC(char *cptr)
{
	HALError *ret;
	HALZeroPage *zp;
	zp=BOARD_RETURNZPLOCATION();

	if(_stdout.get)
	{
		ret=(_stdout.get)(zp->DbgIO_UARTBlk, cptr, 1);
		if(ret) return ret;
	}
	return 0;
}

#ifdef __cplusplus
}
#endif

